wayland::xdg_positioner_t(3)

NAME
wayland::xdg_positioner_t - child surface positioner

SYNOPSIS

#include <wayland-client-protocol-extra.hpp>

Inherits wayland::proxy_t.

  Public Types

enum class wrapper_type { standard, display, foreign, proxy_wrapper }

  Public Member Functions

void set_size (int32_t width, int32_t height)
set the size of the to-be positioned rectangle
void set_anchor_rect (int32_t x, int32_t y, int32_t width, int32_t height)
set the anchor rectangle within the parent surface
void set_anchor (xdg_positioner_anchor const &anchor)
set anchor rectangle anchor
void set_gravity (xdg_positioner_gravity const &gravity)
set child surface gravity
void set_constraint_adjustment (xdg_positioner_constraint_adjustment const &constraint_adjustment)
set the adjustment to be done when constrained
void set_offset (int32_t x, int32_t y)
set surface position offset
void set_reactive ()
continuously reconstrain the surface
bool can_set_reactive () const
Check whether the set_reactive function is available with the currently bound version of the protocol.
void set_parent_size (int32_t parent_width, int32_t parent_height)
bool can_set_parent_size () const
Check whether the set_parent_size function is available with the currently bound version of the protocol.
void set_parent_configure (uint32_t serial)
set parent configure this is a response to
bool can_set_parent_configure () const
Check whether the set_parent_configure function is available with the currently bound version of the protocol.
uint32_t get_id () const
Get the id of a proxy object.
std::string get_class () const
Get the interface name (class) of a proxy object.
uint32_t get_version () const
Get the protocol object version of a proxy object.
wrapper_type get_wrapper_type () const
Get the type of a proxy object.
void set_queue (event_queue_t queue)
Assign a proxy to an event queue.
wl_proxy * c_ptr () const
Get a pointer to the underlying C struct.
bool proxy_has_object () const
Check whether this wrapper actually wraps an object.
operator bool () const
Check whether this wrapper actually wraps an object.
bool operator== (const proxy_t &right) const
Check whether two wrappers refer to the same object.
bool operator!= (const proxy_t &right) const
Check whether two wrappers refer to different objects.
void proxy_release ()
Release the wrapped object (if any), making this an empty wrapper.

  Static Public Attributes

static constexpr std::uint32_t set_size_since_version = 1
Minimum protocol version required for the set_size function.
static constexpr std::uint32_t set_anchor_rect_since_version = 1
Minimum protocol version required for the set_anchor_rect function.
static constexpr std::uint32_t set_anchor_since_version = 1
Minimum protocol version required for the set_anchor function.
static constexpr std::uint32_t set_gravity_since_version = 1
Minimum protocol version required for the set_gravity function.
static constexpr std::uint32_t set_constraint_adjustment_since_version = 1
Minimum protocol version required for the set_constraint_adjustment function.
static constexpr std::uint32_t set_offset_since_version = 1
Minimum protocol version required for the set_offset function.
static constexpr std::uint32_t set_reactive_since_version = 3
Minimum protocol version required for the set_reactive function.
static constexpr std::uint32_t set_parent_size_since_version = 3
Minimum protocol version required for the set_parent_size function.
static constexpr std::uint32_t set_parent_configure_since_version = 3
Minimum protocol version required for the set_parent_configure function.

Detailed Description

child surface positioner

The xdg_positioner provides a collection of rules for the placement of a child surface relative to a parent surface. Rules can be defined to ensure the child surface remains within the visible area's borders, and to specify how the child surface changes its position, such as sliding along an axis, or flipping around a rectangle. These positioner-created rules are constrained by the requirement that a child surface must intersect with or be at least partially adjacent to its parent surface.

See the various requests for details about possible rules.

At the time of the request, the compositor makes a copy of the rules specified by the xdg_positioner. Thus, after the request is complete the xdg_positioner object can be destroyed or reused; further changes to the object will have no effect on previous usages.

For an xdg_positioner object to be considered complete, it must have a non-zero size set by set_size, and a non-zero anchor rectangle set by set_anchor_rect. Passing an incomplete xdg_positioner object when positioning a surface raises an error.

Definition at line 670 of file wayland-client-protocol-extra.hpp.

Member Enumeration Documentation

  enum class wayland::proxy_t::wrapper_type [strong], [inherited]
Underlying wl_proxy type and properties of a proxy_t that affect construction, destruction, and event handling

Enumerator

standard
    C pointer is a standard type compatible with wl_proxy*. Events are dispatched and it is destructed when the proxy_t is destructed. User data is set.

display
    C pointer is a wl_display*. No events are dispatched, wl_display_disconnect is called when the proxy_t is destructed. User data is set.

foreign
    C pointer is a standard type compatible with wl_proxy*, but another library owns it and it should not be touched in a way that could affect the operation of the other library. No events are dispatched, wl_proxy_destroy is not called when the proxy_t is destructed, user data is not touched. Consequently, there is no reference counting for the proxy_t. Lifetime of such wrappers should preferably be short to minimize the chance that the owning library decides to destroy the wl_proxy.

proxy_wrapper
    C pointer is a wl_proxy* that was constructed with wl_proxy_create_wrapper. No events are dispatched, wl_proxy_wrapper_destroy is called when the proxy_t is destroyed. Reference counting is active. A reference to the proxy_t creating this proxy wrapper is held to extend its lifetime until after the proxy wrapper is destroyed.

Definition at line 117 of file wayland-client.hpp.

Member Function Documentation

  wl_proxy * wayland::proxy_t::c_ptr () const [inherited]

Get a pointer to the underlying C struct.

Returns
    The underlying wl_proxy wrapped by this proxy_t if it exists, otherwise an exception is thrown

  bool xdg_positioner_t::can_set_parent_configure () const

Check whether the set_parent_configure function is available with the currently bound version of the protocol.

Definition at line 1168 of file wayland-client-protocol-extra.cpp.

  bool xdg_positioner_t::can_set_parent_size () const

Check whether the set_parent_size function is available with the currently bound version of the protocol.

Definition at line 1157 of file wayland-client-protocol-extra.cpp.

  bool xdg_positioner_t::can_set_reactive () const

Check whether the set_reactive function is available with the currently bound version of the protocol.

Definition at line 1146 of file wayland-client-protocol-extra.cpp.

  std::string wayland::proxy_t::get_class () const [inherited]

Get the interface name (class) of a proxy object.

Returns
    The interface name of the object associated with the proxy

  uint32_t wayland::proxy_t::get_id () const [inherited]

Get the id of a proxy object.

Returns
    The id the object associated with the proxy

  uint32_t wayland::proxy_t::get_version () const [inherited]

Get the protocol object version of a proxy object. Gets the protocol object version of a proxy object, or 0 if the proxy was created with unversioned API.

A returned value of 0 means that no version information is available, so the caller must make safe assumptions about the object's real version.

display_t will always return version 0.

Returns
    The protocol object version of the proxy or 0

  wrapper_type wayland::proxy_t::get_wrapper_type () const [inline], [inherited]

Get the type of a proxy object.

Definition at line 303 of file wayland-client.hpp.

  wayland::proxy_t::operator bool () const [inherited]

Check whether this wrapper actually wraps an object.

Returns
    true if there is an underlying object, false if this wrapper is empty

  bool wayland::proxy_t::operator!= (const proxy_t & right) const [inherited]

Check whether two wrappers refer to different objects.

  bool wayland::proxy_t::operator== (const proxy_t & right) const [inherited]

Check whether two wrappers refer to the same object.

  bool wayland::proxy_t::proxy_has_object () const [inherited]

Check whether this wrapper actually wraps an object.

Returns
    true if there is an underlying object, false if this wrapper is empty

  void wayland::proxy_t::proxy_release () [inherited]

Release the wrapped object (if any), making this an empty wrapper. Note that display_t instances cannot be released this way. Attempts to do so are ignored.

Examples
foreign_display.cpp.

  void xdg_positioner_t::set_anchor (xdg_positioner_anchor const & anchor)

set anchor rectangle anchor

Parameters
    anchor anchor

Defines the anchor point for the anchor rectangle. The specified anchor is used derive an anchor point that the child surface will be positioned relative to. If a corner anchor is set (e.g. 'top_left' or 'bottom_right'), the anchor point will be at the specified corner; otherwise, the derived anchor point will be centered on the specified edge, or in the center of the anchor rectangle if no edge is specified.

Definition at line 1117 of file wayland-client-protocol-extra.cpp.

  void xdg_positioner_t::set_anchor_rect (int32_t x, int32_t y, int32_t width, int32_t height)

set the anchor rectangle within the parent surface

Parameters
    x x position of anchor rectangle
    y y position of anchor rectangle
    width width of anchor rectangle
    height height of anchor rectangle

Specify the anchor rectangle within the parent surface that the child surface will be placed relative to. The rectangle is relative to the window geometry as defined by xdg_surface.set_window_geometry of the parent surface.

When the xdg_positioner object is used to position a child surface, the anchor rectangle may not extend outside the window geometry of the positioned child's parent surface.

If a negative size is set the invalid_input error is raised.

Definition at line 1111 of file wayland-client-protocol-extra.cpp.

  void xdg_positioner_t::set_constraint_adjustment (xdg_positioner_constraint_adjustment const & constraint_adjustment)

set the adjustment to be done when constrained

Parameters
    constraint_adjustment bit mask of constraint adjustments

Specify how the window should be positioned if the originally intended position caused the surface to be constrained, meaning at least partially outside positioning boundaries set by the compositor. The adjustment is set by constructing a bitmask describing the adjustment to be made when the surface is constrained on that axis.

If no bit for one axis is set, the compositor will assume that the child surface should not change its position on that axis when constrained.

If more than one bit for one axis is set, the order of how adjustments are applied is specified in the corresponding adjustment descriptions.

The default adjustment is none.

Definition at line 1129 of file wayland-client-protocol-extra.cpp.

  void xdg_positioner_t::set_gravity (xdg_positioner_gravity const & gravity)

set child surface gravity

Parameters
    gravity gravity direction

Defines in what direction a surface should be positioned, relative to the anchor point of the parent surface. If a corner gravity is specified (e.g. 'bottom_right' or 'top_left'), then the child surface will be placed towards the specified gravity; otherwise, the child surface will be centered over the anchor point on any axis that had no gravity specified.

Definition at line 1123 of file wayland-client-protocol-extra.cpp.

  void xdg_positioner_t::set_offset (int32_t x, int32_t y)

set surface position offset

Parameters
    x surface position x offset
    y surface position y offset

Specify the surface position offset relative to the position of the anchor on the anchor rectangle and the anchor on the surface. For example if the anchor of the anchor rectangle is at (x, y), the surface has the gravity bottom|right, and the offset is (ox, oy), the calculated surface position will be (x + ox, y + oy). The offset position of the surface is the one used for constraint testing. See set_constraint_adjustment.

An example use case is placing a popup menu on top of a user interface element, while aligning the user interface element of the parent surface with some user interface element placed somewhere in the popup surface.

Definition at line 1135 of file wayland-client-protocol-extra.cpp.

  void xdg_positioner_t::set_parent_configure (uint32_t serial)

set parent configure this is a response to

Parameters
    serial serial of parent configure event

Set the serial of an xdg_surface.configure event this positioner will be used in response to. The compositor may use this information together with set_parent_size to determine what future state the popup should be constrained using.

Definition at line 1163 of file wayland-client-protocol-extra.cpp.

  void xdg_positioner_t::set_parent_size (int32_t parent_width, int32_t parent_height)

Parameters
    parent_width future window geometry width of parent
    parent_height future window geometry height of parent

Set the parent window geometry the compositor should use when positioning the popup. The compositor may use this information to determine the future state the popup should be constrained using. If this doesn't match the dimension of the parent the popup is eventually positioned against, the behavior is undefined.

The arguments are given in the surface-local coordinate space.

Definition at line 1152 of file wayland-client-protocol-extra.cpp.

  void wayland::proxy_t::set_queue (event_queue_t queue) [inherited]

Assign a proxy to an event queue.

Parameters
    queue The event queue that will handle this proxy

Assign proxy to event queue. Events coming from proxy will be queued in queue instead of the display's main queue.

See also: display_t::dispatch_queue().

Examples
proxy_wrapper.cpp.

  void xdg_positioner_t::set_reactive ()

continuously reconstrain the surface When set reactive, the surface is reconstrained if the conditions used for constraining changed, e.g. the parent window moved.

If the conditions changed and the popup was reconstrained, an xdg_popup.configure event is sent with updated geometry, followed by an xdg_surface.configure event.

Definition at line 1141 of file wayland-client-protocol-extra.cpp.

  void xdg_positioner_t::set_size (int32_t width, int32_t height)

set the size of the to-be positioned rectangle

Parameters
    width width of positioned rectangle
    height height of positioned rectangle

Set the size of the surface that is to be positioned with the positioner object. The size is in surface-local coordinates and corresponds to the window geometry. See xdg_surface.set_window_geometry.

If a zero or negative size is set the invalid_input error is raised.

Definition at line 1105 of file wayland-client-protocol-extra.cpp.

Member Data Documentation

  constexpr std::uint32_t wayland::xdg_positioner_t::set_anchor_rect_since_version = 1 [static], [constexpr]

Minimum protocol version required for the set_anchor_rect function.

Definition at line 731 of file wayland-client-protocol-extra.hpp.

  constexpr std::uint32_t wayland::xdg_positioner_t::set_anchor_since_version = 1 [static], [constexpr]

Minimum protocol version required for the set_anchor function.

Definition at line 748 of file wayland-client-protocol-extra.hpp.

  constexpr std::uint32_t wayland::xdg_positioner_t::set_constraint_adjustment_since_version = 1 [static], [constexpr]

Minimum protocol version required for the set_constraint_adjustment function.

Definition at line 789 of file wayland-client-protocol-extra.hpp.

  constexpr std::uint32_t wayland::xdg_positioner_t::set_gravity_since_version = 1 [static], [constexpr]

Minimum protocol version required for the set_gravity function.

Definition at line 765 of file wayland-client-protocol-extra.hpp.

  constexpr std::uint32_t wayland::xdg_positioner_t::set_offset_since_version = 1 [static], [constexpr]

Minimum protocol version required for the set_offset function.

Definition at line 812 of file wayland-client-protocol-extra.hpp.

  constexpr std::uint32_t wayland::xdg_positioner_t::set_parent_configure_since_version = 3 [static], [constexpr]

Minimum protocol version required for the set_parent_configure function.

Definition at line 872 of file wayland-client-protocol-extra.hpp.

  constexpr std::uint32_t wayland::xdg_positioner_t::set_parent_size_since_version = 3 [static], [constexpr]

Minimum protocol version required for the set_parent_size function.

Definition at line 852 of file wayland-client-protocol-extra.hpp.

  constexpr std::uint32_t wayland::xdg_positioner_t::set_reactive_since_version = 3 [static], [constexpr]

Minimum protocol version required for the set_reactive function.

Definition at line 828 of file wayland-client-protocol-extra.hpp.

  constexpr std::uint32_t wayland::xdg_positioner_t::set_size_since_version = 1 [static], [constexpr]

Minimum protocol version required for the set_size function.

Definition at line 707 of file wayland-client-protocol-extra.hpp.

Author

Generated automatically by Doxygen for Wayland++ from the source code.